/*++

Copyright (c) 2012 EnvyLogic Inc.  All rights reserved.

Module Name:

    dcusblib.h

Abstract:

    USB 3.0 Device ϱ  api

Author:

	Jogerse
 
Environment:

    user mode only

Notes:
	

Revision History:
	
	Jogerse		2012-03-05		API  ۼ
	Jogerse		2012-06-04		  ø̼ ؼ Լ 

--*/

#pragma once

#ifdef DCUSBLIB_EXPORTS
#define DCUSBLIB_API __declspec(dllexport)
#else
#define DCUSBLIB_API __declspec(dllimport)
#endif

//-------------------------------------------------------------------------------------------------------------------------------
// Definition

// ϰ  ǹ̸ 
#define	DCU_ERR_SUCCESS					0	//    ȣ

#define DCU_STRING_MAXLENGTH			255

#define	DCU_ERR_BASE_START				0x00000000
#define	DCU_ERR_USBDEVICE_START			0x01000000
#define	DCU_ERR_BULKBASE_START			0x02000000
#define	DCU_ERR_BULKREGISTER_START		0x03000000
#define	DCU_ERR_BULKSTREAM_START		0x04000000
#define	DCU_ERR_CTRLBASE_START			0x05000000
#define	DCU_ERR_CTRLFIFO_START			0x06000000
#define	DCU_ERR_SERIALBASE_START		0x07000000
#define DCU_ERR_FRMGR_START				0x08000000
#define DCU_ERR_FRAME_START				0x09000000
#define DCU_ERR_SCRIPT_START			0x0A000000

#define NUM_PACKET_DATA_LIMIT			(128)


#define	FLAG_DELAY_GET_FRAME			0

//-------------------------------------------------------------------------------------------------------------------------------
// structure

typedef struct _DCU_DEVICE_INFO_TAG {
	ULONG       DriverVersion;
	ULONG       USBDIVersion;
	USHORT      BcdUSB;

	USHORT      VendorID;
	USHORT      ProductID;

	bool        bHighSpeed;
	bool        bSuperSpeed;

	char        DeviceName[DCU_STRING_MAXLENGTH];
	char        FriendlyName[DCU_STRING_MAXLENGTH];
	wchar_t     Manufacturer[DCU_STRING_MAXLENGTH];
	wchar_t     Product[DCU_STRING_MAXLENGTH];
	wchar_t     SerialNumber[DCU_STRING_MAXLENGTH];
} DCU_DEVICE_INFO, *PDCU_DEVICE_INFO;

//-------------------------------------------------------------------------------------------------------------------------------
// enumeration Declaration

// ̽ ¸ 
// ̽ ° Ҷ DCUSB_DEVICE_CALLBACK_FUNCTION ݹ Լ APIʿ ȣǸ鼭 μ Ѱ 
enum DCUSB_DEVICE_STATUS
{
	DCU_DEVICE_PLUGOUT = 0,					// ġ ýۿ ŵǴ   μ Բ ȣ
	DCU_DEVICE_PLUGIN,						// ġ ýۿ Ǵ   μ Բ ȣ
	DCU_DEVICE_CHANGED						//   ġ ¿     μ Բ ȣ
};

// TAG  
enum DCUSB_TAG
{
	DCU_TAG_NORMAL = 0,						// Ϲ TAG
	DCU_TAG_NEW_FRAME						// FRAME read new frame 䱸
};

// TARGET 
enum DCUSB_TARGET_ID
{
	DCU_TARGET_I2C = 0,						// I2C Ÿ Target
	DCU_TARGET_SPI,							// SPI Ÿ Target
	DCU_TARGET_FLASH = 7					// FLASH Ÿ Target
};

//-------------------------------------------------------------------------------------------------------------------------------
// callback functions

// DEVICE CALLBACK Լ  
typedef void (*DCUSB_DEVICE_CALLBACK_FUNCTION)(HANDLE hApiHandle, LPVOID pCallbackContext, DCUSB_DEVICE_STATUS nDeviceStatus);

// FRAME CALLBACK Լ  
typedef void (*DCUSB_FRAME_CALLBACK_FUNCTION)(HANDLE hApiHandle, LPVOID pCallbackContext, PVOID pFrame, int lFrameLength);

//-------------------------------------------------------------------------------------------------------------------------------
// Function Declaration

#ifdef __cplusplus
extern "C" {
#endif

/*! 
 *	\fn		DCU_Init
 *	\brief	API  ü , ʱȭ ϰ, ̽ ̺Ʈ   ִ 
 *									츦 Ѵ.
 *	\param	pCallbackContext		ݹ Լ ȣɶ Contextν ޵Ǵ ü.
 *									Ϲ  Contextü   Ͱ ȴ.
 *	\param	pfnDevcieEventFunction	̽ ̺Ʈ   ݹ Լ .
 *									   NULL̸ ̺Ʈ  ʴ´.
 *	\return	  Open Ǿٸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_Init(LPVOID pCallbackContext, 
								  DCUSB_DEVICE_CALLBACK_FUNCTION pfnDevcieEventFunction);

/*! 
 *	\fn		DCU_End
 *	\brief	̽ ݰ  ü API  ü   Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_End();


/*! 
 *	\fn		DCU_GetMaxDevices
 *	\brief	 ̽  ´.
 *	\param	pDeviceNum				̽    .
 *	\return	   DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_GetMaxDevices(int *pDeviceNum);

/*! 
 *	\fn		DCU_GetDeviceInfo
 *	\brief	μ ̽  ´.
 *	\param	iNumDevice				̽    .
 *	\return	   DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_GetDeviceInfo(int iNumDevice, PDCU_DEVICE_INFO pDcDeviceInfo);

/*! 
 *	\fn		DCU_Open
 *	\brief	μ ̽ ȣ شϴ ̽ Ѵ.
 *	\param	iNumDevice				ġ  ̽ ȣ.
 *	\param	pDeviceHandle			 ̽ ̽ ڵ.
 *	\return	   DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_Open(int iNumDevice, HANDLE *pDeviceHandle);

/*! 
 *	\fn		DCU_Close
 *	\brief	μ ڵ  ġ ݴ´.
 *	\param	hDevice					 ̽ ̽ ڵ.
 *	\return	 ġ Closeϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_Close(HANDLE hDevice);

/*! 
 *	\fn		DCU_RunScript
 *	\brief	 ġ script  Ѵ.
 *	\param	hDevice					 ̽ ̽ ڵ.
 *	\param	lpszScriptFile			 ũƮ 
 -	\param	pfnScriptCallback		ũƮ   ڿ ޾ƺ  ִ callback
 -	\param	pCallbackContext		Callback Լ  context ü .
 *	\return	ũƮ ϴµ ϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_RunScript(HANDLE hDevice, const char *lpszScriptFile);

/*! 
 *	\fn		DCU_GetScriptError
 *	\brief	DCU_RunScript   ߻ߴٸ,   ΰ  .
 *	\param	hDevice					 ̽ ̽ ڵ.
 *	\param	pLine					 ߻   
 -	\param	pCause					   ޸ 
 -	\param	iLength					pCause ũ
 *	\return	 µ ϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_GetScriptError(HANDLE hDevice, int *pLine, char *pCause, int iLength);

/*! 
 *	\fn		DCU_GetVersion
 *	\brief	ش ̽   ´.
 */
DCUSBLIB_API int _stdcall DCU_GetVersion(HANDLE hDevice, DWORD *pDllVer, DWORD *pDrvVer, DWORD *pChipVer);

/*! 
 *	\fn		DCU_SetCapInfo
 *	\brief	̹  Ʈ Ѵ.
 *	\param	hDevice					 Ʈ ̽ ̽ ڵ.
 *	\param	iSource					Frame Է Source 
 *										0: TEST PATTERN
 *										1: MIPI
 *										2: PARALLE
 *	\param	iWidth					Frame .
 *	\param	iHeight					Frame .
 *	\param	iBpp					 ȼ bit .
 *	\param	iSkip					Skip Frame .
 *	\param	iFormat					Frame  
 *										0: YUV16
 *										1: RGB16
 *										2: RAW10
 *	\return	  ϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_SetCapInfo(HANDLE hDevice, int iSource, int iWidth, int iHeight, int iBpp, int iSkip, int iFormat);

/*! 
 *	\fn		DCU_GetCapInfo
 *	\brief	̹  Ʈ Ѵ.
 *	\param	hDevice					 Ʈ ̽ ̽ ڵ.
 *	\param	iSource					Frame Է Source 
 *										0: TEST PATTERN
 *										1: MIPI
 *										2: PARALLE
 *	\param	iWidth					Frame .
 *	\param	iHeight					Frame .
 *	\param	iBpp					 ȼ bit .
 *	\param	iSkip					Skip Frame .
 *	\return	  ϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_GetCapInfo(HANDLE hDevice, int *pSource, int *pWidth, int *pHeight, int *pBpp, int *pSkip, int *pFormat);

/*! 
 *	\fn		DCU_Start
 *	\brief	ڵ Ű ġ DMA  Ѵ.
 *	\param	hDevice					  ̽ ڵ.
 *	\return	  ϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_Start(HANDLE hDevice);

/*! 
 *	\fn		DCU_Stop
 *	\brief	ڵ Ű ġ DMA  .
 *	\param	hDevice					  ̽ ڵ.
 *	\return	  ߸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_Stop(HANDLE hDevice);

/*! 
 *	\fn		DCU_GetFrame
 *	\brief	 ӿ شϴ ͸ ´.
 *	\param	hDevice					Frame ޾ƿ ̽ ڵ
 *	\param	iBlocked				iBlocked == 1 ̸   ٸ.
 *									iBlocked == 0 ̸   
 *	wparam	pCount					 RING BUFFER   Ѵ.
 *	\param	ppBuf					FrameBuffer ͸ ޾ƿ  
 *	\param	pLen					Frame ſ ϸ ŵ Frame ũⰡ .
 *	\return	 ͸ ϸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_GetFrame(HANDLE hDevice, int iBlocked, int *pCount, PBYTE *ppBuf, int *pLen);

/*! 
 *	\fn		DCU_CancelFrame
 *	\brief	 DCU_GetFrame Cancelϰ  Ų.
 *	\param	hDevice					Ʈ  ̽ ̽ ڵ.
 *	\return	 CancelǸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_CancelFrame(HANDLE hDevice);

/*! 
 *	\fn		DCU_GetFrameAsync
 *	\brief	 񵿱 ޱ  Callback ϰ ϴ Լ
 *	\param	hDevice					񵿱   ̽ ڵ.
 *	\param	pfnFrameCallback		   ȣ callback Լ .
 *	\param	pCallbackContext		Callback Լ  context ü .
 *	\return	 CancelǸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_GetFrameAsync(HANDLE hDevice, 
											DCUSB_FRAME_CALLBACK_FUNCTION pfnFrameCallback, LPVOID pCallbackContext);

/*! 
 *	\fn		DCU_SerWrite
 *	\brief	ø   ͸ Ѵ(I2C, SPI, ...)
 *	\param	hDevice					͸  ̽ ڵ.
 *	\param	iTarget					 ø  Target ȣ
 *										0: i2c
 *										1: spi
 *										2 ~ 7: reserved
 *	\param	iSpeed					ø  Ŭ ӵ
 *										- i2c speed
 * 										0  =   48.8 Kbps
 *										1  =   97.6 Kbps
 *										2  =  195.3 Kbps
 *										3  =  390.6 Kbps
 *
 *										- spi speed
 *										0  =   1 Mbps
 *										1  =   5 Mbps
 *										2  =  10 Mbps
 *										3  =  25 Mbps
 *	\param	bStart					͸ ϱ  START ̽ Ÿ flag
 *	\param	bLast					Ͱ   END ̽ Ÿ flag
 *	\param	pBuf					I2C  ͸ Ű 
 *	\param	dwLength				I2C   
 *	\return	 ۵Ǹ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */

DCUSBLIB_API int _stdcall DCU_SerWrite(HANDLE hDevice, int iTarget, int iSpeed, bool bStart, bool bLast, unsigned char *pBuf, int iLength);

/*! 
 *	\fn		DCU_SerRead
 *	\brief	ø   ͸ о帰(I2C, SPI, ...)
 *	\param	hDevice					͸  ̽ ڵ.
 *	\param	iTarget					 ø  Target ȣ
 *										0: i2c
 *										1: spi
 *										2 ~ 7: reserved
 *
 *	\param	iSpeed					ø  Ŭ ӵ
 *										- i2c speed
 * 										0  =   48.8 Kbps
 *										1  =   97.6 Kbps
 *										2  =  195.3 Kbps
 *										3  =  390.6 Kbps
 *
 *										- spi speed
 *										0  =   1 Mbps
 *										1  =   5 Mbps
 *										2  =  10 Mbps
 *										3  =  25 Mbps
 *
 *	\param	bStart					͸ ϱ  START ̽ Ÿ flag
 *	\param	bLast					Ͱ   END ̽ Ÿ flag
 *	\param	pBuf					I2C  ͸ Ű 
 *	\param	dwLength				I2C   
 *	\return	 ۵Ǹ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */

DCUSBLIB_API int _stdcall DCU_SerRead(HANDLE hDevice, int iTarget, int iSpeed, bool bStart, bool bLast, unsigned char *pBuf, int iLength);

/*! 
 *	\fn		DCU_Dump
 *	\brief	flag Ʈ DWORD I2C ͸ ״ ϰ,  Է ִٸ  ۿ  rReadLength Ѵ
 *	\param	hDevice					  о帱 ̽ ̽ ڵ.
 *	\param	pData					I2C  flag Ʈ DWORD  
 *										: parameter bit map
 *										: 	Bit(31~16)	reserved (=0)
 *										:	Bit(15)		generate START prior to data transfer
 *										:	Bit(14)		generate STOP after data transfer
 *										:	Bit(13~12)	clock speed control
 *										:	Bit(11~9)	Target ID
 *										:		000 is reserved for CamI2C (J4-6, 8)
 *										:		001 is reserved for CamSPI (J4-18, 20, 22, 24)
 *										:		Others  are reserved for internal use.
 *										:	Bit(8)		data direction (1=read, 0=write)
 *										:	Bit(7~0)	8-bit data to send
 *	\param	pLength					DWORD     Dump ϸ о帰   .
 *	\return	  оȴٸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_Dump(HANDLE hDevice, unsigned int *pData, int *pLength);

/*! 
 *	\fn		DCU_RegWrite
 *	\brief	 Address  迭 ͸ Ϳ ʷ  ִ´..
 *	\param	hDevice					   ̽ ̽ ڵ.
 *	\param	dwStartAddress			ֱ    ּ
 *	\param	pRegArray				 Ͱ ִ DWORD 迭 .
 *	\param	lLen					pRegArray 
 */
DCUSBLIB_API int _stdcall DCU_RegWrite(HANDLE hDevice, bool bFixed, int iStartAddress, int iTag, unsigned long *pRegArray, int iLen);

/*! 
 *	\fn		DCU_RegRead
 *	\brief	 Register Address    о 迭 ִ´.
 *	\param	hDevice					  о帱 ̽ ̽ ڵ.
 *	\param	dwStartAddress			о̱    ּ
 *	\param	pRegArray				о帰 ͸  DWORD 迭 .
 *	\param	lLen					pRegArray .
 */
DCUSBLIB_API int _stdcall DCU_RegRead(HANDLE hDevice, bool bFixed, int iStartAddress, int iTag, unsigned long *pRegArray, int *pLen);

/*! 
 *	\fn		DCU_SetMclkFreq
 *	\brief	MCLK ļ Ѵ.
 *	\param	hDevice					MCLK ļ  ̽ ڵ
 *	\param	fFreq					 MCLK ļ(MHz )
 *	\return	 ļ Ǿٸ DCU_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
DCUSBLIB_API int _stdcall DCU_SetMclkFreq(HANDLE hDevice, double fFreq);

/*! 
 *	\fn		DCU_GetErrMsg
 *	\brief	 ڵ忡 شϴ  ޽ ´.
 *	\param	iErrCode				޽ ⸦ ϴ  ڵ
 *	\return	 ڵ忡 شϴ ޽ ִٸ  ޽ ϰ, 
 *			 ڵ忡 شϴ ޽ ٸ "IT'S NOT IN ERROR LIST" Ѵ.
 */
DCUSBLIB_API const char * _stdcall DCU_GetErrMsg(int iErrCode);

#ifdef __cplusplus
}
#endif
