// SourceDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "viewUsb3.h"
#include "SourceDlg.h"
#include "common.h"

#include <vector>
#include <sstream>


const int ID_TIMER_PERFOMANCE = WM_USER + 101;


// CSourceDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CSourceDlg, CDialog)

CSourceDlg::CSourceDlg(IFrameCapture *pFrameCapture)
	: CDialog(CSourceDlg::IDD, NULL)
	, m_bFixed(FALSE)
	, m_strData(_T(""))
	, m_strScriptDirectory(_T(""))
{
	m_pFrameCapture = pFrameCapture;
	m_hHandle		= NULL;

	m_hXferThread	= NULL;
	m_uXferThreadID	= 0;
	m_bXferLooping	= FALSE;

	// RGB24 ȯ 
	m_pRgb24		= NULL;
	m_iRgb24		= 0;
	m_iWidth		= 0;
	m_iHeight		= 0;
	m_iBpp			= 16;
	m_iFormat		= 0;

	m_bSave			= false;
}

CSourceDlg::~CSourceDlg()
{
}

void CSourceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_SELECT_DEVICE, m_cmbSelectDevice);
	DDX_Control(pDX, IDC_EDIT_ADDRESS, m_edAddress);
	DDX_Control(pDX, IDC_EDIT_READ_COUNT, m_edReadCount);
	DDX_Check(pDX, IDC_CHECK_FIXED, m_bFixed);
	DDX_Text(pDX, IDC_EDIT_ADDRESS2, m_strData);
	DDX_Control(pDX, IDC_BUTTON_WRITE, m_btnWrite);
	DDX_Control(pDX, IDC_BUTTON_READ, m_btnRead);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_FILE, m_strScriptDirectory);
	DDX_Control(pDX, IDC_BUTTON_SCRIPT_GROUP0, m_btnScriptGroup[0]);
	DDX_Control(pDX, IDC_BUTTON_SCRIPT_GROUP1, m_btnScriptGroup[1]);
	DDX_Control(pDX, IDC_BUTTON_SCRIPT_GROUP2, m_btnScriptGroup[2]);
	DDX_Control(pDX, IDC_BUTTON_SCRIPT_GROUP3, m_btnScriptGroup[3]);
	DDX_Control(pDX, IDC_BUTTON_SCRIPT_GROUP4, m_btnScriptGroup[4]);
	DDX_Control(pDX, IDC_BUTTON_SCRIPT_GROUP5, m_btnScriptGroup[5]);
	DDX_Control(pDX, IDC_BUTTON_STREAM_START, m_btnStreamStart);
	DDX_Control(pDX, IDC_BUTTON_STREAM_STOP, m_btnStreamStop);
	DDX_Control(pDX, IDC_LIST_LOG, m_listLog);
	DDX_Control(pDX, IDC_EDIT_PERFORMANCE, m_editPerformance);
	DDX_Control(pDX, IDC_EDIT_MIPI_VS_COUNT, m_editMipiVsCount);
	DDX_Control(pDX, IDC_EDIT_MIPI_HS_COUNT, m_editMipiHsCount);
	DDX_Control(pDX, IDC_EDIT_MIPI_DE_COUNT, m_editMipiDeCount);
	DDX_Control(pDX, IDC_BUTTON_STREAM_SAVE, m_btnStreamSave);
}


BEGIN_MESSAGE_MAP(CSourceDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, &CSourceDlg::OnBnClickedButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_READ, &CSourceDlg::OnBnClickedButtonRead)
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_COMBO_SELECT_DEVICE, &CSourceDlg::OnCbnSelchangeComboSelectDevice)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_SCRIPT, &CSourceDlg::OnBnClickedButtonBrowseScript)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_BUTTON_SCRIPT_GROUP0,IDC_BUTTON_SCRIPT_GROUP5, OnBnClickedButtonsGroups ) 
	ON_BN_CLICKED(IDC_BUTTON_STREAM_START, &CSourceDlg::OnBnClickedButtonStreamStart)
	ON_BN_CLICKED(IDC_BUTTON_STREAM_STOP, &CSourceDlg::OnBnClickedButtonStreamStop)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CSourceDlg::OnBnClickedButtonClear)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_STREAM_SAVE, &CSourceDlg::OnBnClickedButtonStreamSave)
END_MESSAGE_MAP()


// CSourceDlg ޽ óԴϴ.

BOOL CSourceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.
	int left	= AfxGetApp()->GetProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_LEFT,	20);
	int right	= AfxGetApp()->GetProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_RIGHT,	520);
	int top		= AfxGetApp()->GetProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_TOP,	20);
	int bottom	= AfxGetApp()->GetProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_BOTTOM,420);

	::SetWindowPos( GetSafeHwnd(),
					NULL,
					left, top,
					right - left, bottom - top,
					SWP_NOSIZE | SWP_NOZORDER);

	// dcusblib ʱȭ
	if(DCU_Init(this, OnEventDeviceCallback) == DCU_ERR_SUCCESS)
	{
		OnChangeDeviceStatus();
	}

	m_strScriptDirectory = AfxGetApp()->GetProfileString(VIEWUSB3_SECTION_SCRIPT, 
													VIEWUSB3_ENTRY_FILEPATH, NULL);

	UpdateData(FALSE);

	//   Ʈ 
	int iWidthPad = max_frame_width * 3;
	// 4Ʈ   Padding byte ߰
	while(iWidthPad % 4 != 0)
		iWidthPad++;

	// е  ü ޸ ũ
	m_iRgb24 = iWidthPad * max_frame_height;

	// ޸ Ҵ
	m_pRgb24 = new BYTE[m_iRgb24];
	if(m_pRgb24 == NULL)
	{
		AfxMessageBox("Memory Allocation for RGB24 ERROR");
	}

	LoadScript();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CSourceDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	CRect rcWindow; GetWindowRect( rcWindow );
	AfxGetApp()->WriteProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_LEFT,	rcWindow.left);
	AfxGetApp()->WriteProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_RIGHT,	rcWindow.right);
	AfxGetApp()->WriteProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_TOP,	rcWindow.top);
	AfxGetApp()->WriteProfileInt(VIEWUSB3_SECTION_SOURCE, VIEWUSB3_ENTRY_BOTTOM,rcWindow.bottom);

	// START ̸ STOP Ŵ
	if(m_bXferLooping)
		OnBnClickedButtonStreamStop();

	// API release
	int iErrCode = DCU_End();

	// ޸ 
	if(m_pRgb24)
	{
		delete [] m_pRgb24;
		m_pRgb24 = NULL;
	}
}

void CSourceDlg::OnOK()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	//CDialog::OnOK();
}

void CSourceDlg::OnCancel()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	//CDialog::OnCancel();
}

void CSourceDlg::OnBnClickedButtonWrite()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);

	DWORD dwAddress = m_edAddress.GetValue();

	std::vector<DWORD> datas;

	TRACE("DATA:\n");
	int i = 0;
	CString strToken = m_strData.Tokenize(",", i);
	while(strToken != "")
	{
		DWORD data = 0;
		std::stringstream ss;
		if(strToken.Find("0x") != -1)
			ss << std::hex << strToken;
		else
			ss << strToken;

		ss >> data;
		TRACE("%s -> %d\n", strToken, data);
		datas.push_back(data);

		strToken = m_strData.Tokenize(",", i);
	}
	TRACE("%d EA\n", datas.size());

	int iErrCode = DCU_RegWrite(m_hHandle, false, dwAddress, DCU_TAG_NORMAL, &datas[0], datas.size());
	if(iErrCode != DCU_ERR_SUCCESS)
	{
		CString strMsg;
		strMsg.Format("OnBnClickedBtnWrite: %08X(%s)", iErrCode, DCU_GetErrMsg(iErrCode));
		AfxMessageBox(strMsg);
		return;
	}

	m_edReadCount.SetValue(datas.size());
	UpdateData(FALSE);
}

void CSourceDlg::OnBnClickedButtonRead()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);

	int iAddr	= m_edAddress.GetValue();
	int iLen	= m_edReadCount.GetValue();

	if(iLen == 0)
	{
		AfxMessageBox("Read Count must not zero");
		return;
	}

	std::vector<DWORD> datas(iLen);
	
	int iErrCode = DCU_RegRead(m_hHandle, false, iAddr, DCU_TAG_NORMAL, &datas[0], &iLen);
	if(iErrCode != DCU_ERR_SUCCESS)
	{
		CString strMsg;
		strMsg.Format("OnBnClickedBtnRead: %08X(%s)", iErrCode, DCU_GetErrMsg(iErrCode));
		AfxMessageBox(strMsg);
		return;
	}

	CString strMsg;
	std::vector<DWORD>::iterator it;
	for(it = datas.begin(); it != datas.end(); it++)
	{
		if(it != datas.begin())
		{
			strMsg += ",";
		}

		CString strValue;
		strValue.Format("0x%08X", *it);
		strMsg += strValue;
	}
	m_strData = strMsg;
	m_edReadCount.SetValue(iLen);
	UpdateData(FALSE);
}


void CSourceDlg::OnChangeDeviceStatus()
{
	int iNumCards = 0;
	int iErrCode = DCU_GetMaxDevices(&iNumCards);

	m_cmbSelectDevice.ResetContent();

	for(int i = 0; i < iNumCards; i++)
	{
		DCU_DEVICE_INFO DcDeviceInfo;
		if(DCU_GetDeviceInfo(i, &DcDeviceInfo) == DCU_ERR_SUCCESS)
		{
			CString strName;
			strName.Format(_T("%s - %02d"), DcDeviceInfo.FriendlyName, i);
			m_cmbSelectDevice.AddString(strName);
		}
	}

	UpdateButtons();
}

void CSourceDlg::OnChangeDeviceStatus(DCUSB_DEVICE_STATUS nDeviceStatus)
{
	int iNumCards = 0;
	int iErrCode = DCU_GetMaxDevices(&iNumCards);

	switch(nDeviceStatus)
	{
	case DCU_DEVICE_PLUGOUT:
		{
			TRACE(_T("DCU_DEVICE_PLUGOUT: %d\n"),  iNumCards);

			// ȭ鿡 ϱ  Timer 
			KillTimer(ID_TIMER_PERFOMANCE);
		}
		break;

	case DCU_DEVICE_PLUGIN:
		{
			TRACE(_T("DCU_DEVICE_PLUGIN: %d\n"), iNumCards);
		}
		break;
	}

	OnChangeDeviceStatus();
}


void CSourceDlg::OnEventDeviceCallback(HANDLE hApiHandle, LPVOID pCallbackContext, DCUSB_DEVICE_STATUS nDeviceStatus)
{
	CSourceDlg *pDlg = (CSourceDlg *)pCallbackContext;
	if(pDlg) pDlg->OnChangeDeviceStatus(nDeviceStatus);
}

void CSourceDlg::OnFrameCallback(HANDLE hDevice, PVOID pFrame, int iLength)
{
	TRACE("OnFrameCallback(%X, %X, %X)\n", hDevice, pFrame, iLength);

	OnCapture(reinterpret_cast<PBYTE>(pFrame), iLength, 1);

	m_iFrameCount++;
}

void CSourceDlg::OnEventFrameCallback(HANDLE hDevice, PVOID pContext, PVOID pFrame, int iLength)
{
	CSourceDlg *pDlg = (CSourceDlg *)pContext;
	if(pDlg) pDlg->OnFrameCallback(hDevice, pFrame, iLength);
}

void CSourceDlg::UpdateButtons()
{
	m_btnRead.EnableWindow(m_hHandle != NULL);
	m_btnWrite.EnableWindow(m_hHandle != NULL);

	m_btnStreamStart.EnableWindow(m_hHandle != NULL && m_bXferLooping == FALSE);
	m_btnStreamStop.EnableWindow(m_hHandle != NULL && m_bXferLooping != FALSE);
	m_btnStreamSave.EnableWindow(m_hHandle != NULL && m_bXferLooping != FALSE);
}

void CSourceDlg::LogOut(char *fmt, ...)
{
	char szMsg[4096];

	if(::IsWindow(GetSafeHwnd()) == FALSE)
		return;

	//EnterCriticalSection(&m_cs);

	va_list para;
	va_start(para,fmt);
	vsprintf_s(szMsg, 4096, fmt, para);
	va_end(para);

	CTime tm = CTime::GetCurrentTime();
	CString strDate = tm.Format("[%H:%M:%S] ");

	m_listLog.AddString(strDate + szMsg);
	m_listLog.SetTopIndex(m_listLog.GetCount() - 1);

	//m_arOutputLog.Add(szMsg);
	//PostMessage(WM_USER_LOG_MESSAGE);

	//LeaveCriticalSection(&m_cs);
}

void CSourceDlg::LogOut(LPCTSTR lpszMsg)
{
	if(::IsWindow(GetSafeHwnd()) == FALSE)
		return;

	CTime tm = CTime::GetCurrentTime();
	CString strDate = tm.Format("[%H-%M-%S] ");

	m_listLog.AddString(strDate + lpszMsg);
	m_listLog.SetTopIndex(m_listLog.GetCount() - 1);

	//EnterCriticalSection(&m_cs);

	//m_arOutputLog.Add(lpszMsg);
	//PostMessage(WM_USER_LOG_MESSAGE);

	//LeaveCriticalSection(&m_cs);
}

void CSourceDlg::LogClear()
{
	if(::IsWindow(GetSafeHwnd()) == FALSE)
		return;

	//EnterCriticalSection(&m_cs);

	m_listLog.ResetContent();

	//LeaveCriticalSection(&m_cs);
}



void CSourceDlg::OnCbnSelchangeComboSelectDevice()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	//  Open ġ ִٸ ġ close
	if(m_hHandle)
	{
		DCU_Close(m_hHandle);
		m_hHandle = NULL;
	}

	// ο õ ġ 
	int iNumSelected = m_cmbSelectDevice.GetCurSel();
	if(iNumSelected == -1) return;

	int iErrCode = DCU_Open(iNumSelected, &m_hHandle);
	if(iErrCode != DCU_ERR_SUCCESS)
	{
		CString strMsg;
		strMsg.Format("OnCbnSelchangeComboDevices: %d(%s)", iErrCode, DCU_GetErrMsg(iErrCode));
		AfxMessageBox(strMsg);
		return;
	}

	// ȭ鿡 ϱ  Timer 
	SetTimer(ID_TIMER_PERFOMANCE, 1000, NULL);

	UpdateButtons();
}

// ݹ鿡 ϴ Ķ ü
struct BFFParam
{
	const void* pData;
	bool isString;
};

// ݹ
int CALLBACK _BFFProc(HWND hwnd, UINT msg, LPARAM lparam, LPARAM data)
{
	//  ޽ 
	if (msg == BFFM_INITIALIZED)
	{
		// ̷ ؼ ϴ  ϵ ϸ ȴ.
		BFFParam* pData = (BFFParam*)data;
		if (pData != NULL)
			SendMessage(hwnd, BFFM_SETSELECTION, (pData->isString) ? TRUE : FALSE, (LPARAM)(pData->pData));
	}

	// ٸ   0 ȯؾ Ѵ
	return 0;
}

// title  pInitFolder õǵ   ȭڸ ǥѴ.
PIDLIST_ABSOLUTE browseForFolder(HWND hwnd, LPSTR dispName, const char *title, const void* pInitFolder, bool bIsString)
{
	BFFParam param;
	param.pData			= pInitFolder;
	param.isString		= bIsString;

	BROWSEINFO bi		= {0};
	bi.hwndOwner		= hwnd;
	bi.pszDisplayName	= dispName;
	bi.lpszTitle		= title;
	bi.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_EDITBOX | BIF_RETURNONLYFSDIRS;
	bi.lParam			= (LPARAM)(BFFParam *)&param;
	bi.lpfn				= _BFFProc;
	return SHBrowseForFolder(&bi);
}

void CSourceDlg::OnBnClickedButtonBrowseScript()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BROWSEINFO BrInfo;
	TCHAR szBuffer[MAX_PATH];                                      //  

	::ZeroMemory(&BrInfo, sizeof(BROWSEINFO));
	::ZeroMemory(szBuffer, MAX_PATH);

	UpdateData(TRUE);

	LPITEMIDLIST pItemIdList = browseForFolder(GetSafeHwnd(), NULL, NULL, m_strScriptDirectory.GetBuffer(), TRUE);

	//   ϸ NULL
	if(pItemIdList == NULL) return;

	//   
	::SHGetPathFromIDList(pItemIdList, szBuffer);

	CString strDirectory = szBuffer;
	if(!strDirectory.IsEmpty())
		m_strScriptDirectory = strDirectory;
	UpdateData(FALSE);

	AfxGetApp()->WriteProfileString(VIEWUSB3_SECTION_SCRIPT, VIEWUSB3_ENTRY_FILEPATH, m_strScriptDirectory);

	LoadScript();
}

void show_error(const char* error)
{
	TRACE("_ALERT -> %s\n", error);
}

void CSourceDlg::OnBnClickedButtonsGroups(UINT nID)
{
	// ġ µǾ  ʴٸ  .
	if(m_hHandle == NULL)
	{
		AfxMessageBox("Need Open USB Frame Grabber Device.");
		return;
	}

	//  ư ε 
	UINT iIndex = nID - IDC_BUTTON_SCRIPT_GROUP0;

	// ư شϴ script  ̸ ´.
	std::string path = m_strScriptDirectory + "\\" + m_listEcs[iIndex].c_str();
	std::string msg = "Run script " + m_listEcs[iIndex];
	LogOut(msg.c_str());
	
	// õ ũƮ 
	int iErrCode = DCU_RunScript(m_hHandle, path.c_str());
	if(iErrCode != DCU_ERR_SUCCESS)
	{
		CString strMsg;
		strMsg.Format("ERR: DCU_RunScript, %d, %s", iErrCode, DCU_GetErrMsg(iErrCode));
		LogOut(strMsg);

		int iLine = 0;
		std::vector<char> cause(1024);
		iErrCode = DCU_GetScriptError(m_hHandle, &iLine, &cause[0], cause.size());
		LogOut("ERR: [%04d] %s", iLine, &cause[0]);
		return;
	}

	LogOut("Run OK");
}

void YtoRGB24(PBYTE pYuvBuf, ULONG lYuvLength, 
			  PBYTE pBmpBuf, ULONG lBmpLength, ULONG lWidth, ULONG lHeight)
{
	//int yuvcount = 0;
	//int rgbcount = 0;

	int b_line_length = lBmpLength / lHeight;
	int	y_line_start, b_line_start;

	for(ULONG i = 0; i < lHeight;i++) 
	{
		y_line_start = i * lWidth;
		// BMP Ʒ   ϵȴ.
		b_line_start = (lHeight - i - 1) * b_line_length;

        for(ULONG j = 0 ; j < lWidth ; j++) 
		{
            BYTE bData = pYuvBuf[y_line_start + j];
			ULONG lRgbIndex = (b_line_start + j * 3);
			if(lRgbIndex + 2 >= lBmpLength)
			{
				TRACE("Point Overflow: %d, %d > %d\n", j, b_line_start, lBmpLength);
				return;
			}

			pBmpBuf[(b_line_start + j * 3) + 0] = (BYTE)bData;
			pBmpBuf[(b_line_start + j * 3) + 1] = (BYTE)bData;
			pBmpBuf[(b_line_start + j * 3) + 2] = (BYTE)bData;
		}
	}
}

void RGB16toRGB24(PVOID pRgb16, LONG lSrcSize, PVOID pRgb24, LONG lDstSize, ULONG lWidth, ULONG lHeight)
{
	if(pRgb24 == NULL || pRgb16 == NULL)
		return;

	// ü ȼ  
	LONG lPixelCount = lWidth * lHeight;

	// ҽ  ũ   ũⰡ  
	LONG lSrcCount		= lSrcSize / sizeof(WORD);
	LONG lDstCount		= lDstSize / sizeof(DWORD);
	//if(lPixelCount != lDstCount || lPixelCount != lSrcCount)
	//	return;

	//  ͸ 
	PWORD pRgb16Buffer	= (PWORD)pRgb16;
	PBYTE pRgb24Buffer	= (PBYTE)pRgb24;

	int iSrcCount = 0;

	// ȼ  ư鼭 Ʒ   ȯ
	for(ULONG iY = 0; iY < lHeight; iY++)
	{
		int iRgbCount = (iY * lWidth * 3);

		for(ULONG iX = 0; iX < lWidth; iX++)
		{
			BYTE bRed	= (BYTE)((pRgb16Buffer[iSrcCount] & 0xF800) >> 8);
			BYTE bGreen	= (BYTE)((pRgb16Buffer[iSrcCount] & 0x07E0) >> 3);
			BYTE bBlue	= (BYTE)((pRgb16Buffer[iSrcCount] & 0x001F) << 3);

			pRgb24Buffer[iRgbCount + 0] = bBlue;
			pRgb24Buffer[iRgbCount + 1] = bGreen;
			pRgb24Buffer[iRgbCount + 2] = bRed;

			iRgbCount += 3;
			iSrcCount++;
		}
	}
}

static BYTE chbit(BYTE a)
{
	BYTE r;
	//int i;

	r = a;

	return r;

	if (a&(1<<7)) {
		r |= (1<<6);
	}
	else {
		r &= ~(1<<6);
	}

	if (a&(1<<6)) {
		r |= (1<<7);
	}
	else {
		r &= ~(1<<7);
	}

	if (a&(1<<5)) {
		r &= ~(1<<5);
	}
	else {
		r |= (1<<5);
	}

	return r;
}

void YUV16toRGB24(PBYTE pYuv16, int iSrcSize, PBYTE pRgb24, int iDstSize, int iWidth, int iHeight)
{
	int		r1, g1, b1, r2, g2, b2, u, v, cb, cr,y1,y2;
	//int     i,j;
	int     xxx,yyy;
	int     yuvcount;
	int     rgbcount;
	 
	yuvcount = 0;

    for( yyy = 0 ; yyy < iHeight ; yyy++ ) 
	{
		rgbcount =   (yyy*iWidth*3);
        for( xxx = 0 ; xxx < iWidth ; xxx++) 
		{
		
//			if (data & 0x80) data &= ~(1<<7);
//			else data |= (1<<7);
		
			// micron mode

			cb = chbit(pYuv16[ yuvcount*4 + 0]) - 128;
            y1 = pYuv16[ yuvcount*4 + 1];
			y1 = chbit(y1);

			cr = chbit(pYuv16[ yuvcount*4 + 2])- 128;;

            y2 = pYuv16[ yuvcount*4 + 3];
			y2 = chbit(y2);

			/*
            y1 = pYuv16[ yuvcount*4 + 0];
			cr = pYuv16[ yuvcount*4 + 1] - 128;
            y2 = pYuv16[ yuvcount*4 + 2];
			cb = pYuv16[ yuvcount*4 + 3] - 128;
			*/



			/*
			cb = pYuv16[ yuvcount*4 + 2] - 128;
            y1 = pYuv16[ yuvcount*4 + 1];
			cr = pYuv16[ yuvcount*4 + 0] - 128;
            y2 = pYuv16[ yuvcount*4 + 3];
			*/


			yuvcount++;
			/////////////////////////////////	
			u = cb * 2 + 1;
			v = (cr * 1600 + 800)/1000;

			////////////////////////////////////
			r1 = v + y1;
			b1 = u + y1;
			//g1 = (int)((y1 - 0.299 * r1 - 0.114 * b1) / 0.587);       
			g1 = (int)((1000*y1 - 299 * r1 - 114 * b1) / 587);       

			if(r1 <= 0 ) r1 = 0;  if(r1 > 255) r1 = 255;
			if(g1 <= 0)  g1 = 0;  if(g1 > 255) g1 = 255;
			if(b1 <= 0)  b1 = 0;  if(b1 > 255) b1 = 255;

            pRgb24[rgbcount+0] = (BYTE)b1;
            pRgb24[rgbcount+1] = (BYTE)g1;
            pRgb24[rgbcount+2] = (BYTE)r1;


			xxx++;  // xdot ϳ ...
           	rgbcount += 3;

			r2 = v + y2;
			b2 = u + y2;
			g2 = (int)((1000*y2 - 299 * r2 - 114 * b2) / 587);

			if(r2 <= 0 ) r2 = 0;  if(r2 > 255) r2 = 255;
			if(g2<= 0)  g2 = 0;  if(g2 > 255) g2 = 255;
			if(b2<= 0)  b2 = 0;  if(b2 > 255) b2 = 255;	

            pRgb24[rgbcount+0] = (BYTE)b2;
            pRgb24[rgbcount+1] = (BYTE)g2;
            pRgb24[rgbcount+2] = (BYTE)r2;
           	rgbcount += 3;
		}
	}
}

//void Xiaomi_RAW10_to_RGB24(PBYTE pSrc, int iSrcSize, PBYTE pDst, int iDstSize, int iWidth, int iHeight)
//{
//	memset(pDst,0,iDstSize);
//
//	int src_bw = (iWidth*5/4+3)/4*4;
//	int src_h = iSrcSize/src_bw;
//
//	int dst_bw = (iWidth*3+3)/4*4;
//	int dst_h = iDstSize/dst_bw;
//
//	//	fill raw data
//	for (int y=0; y<src_h && y<dst_h; y++) {
//		int dst_xoff = y*dst_bw;
//		int src_xoff = y*src_bw;
//		for (int x=0, src_x=0; x<(iWidth/4*4); x+=4, src_x+=5) {
//			for (int i=0, dst_x=x*3; i<4; i++, dst_x+=3) {
//				int csel = 2-(y%2)-(i%2);
//				unsigned int value = ((unsigned int)pSrc[src_xoff+src_x+i])*3;
//				if (value>255)	value = 255;
//				pDst[dst_xoff+dst_x+csel] = (BYTE)(value & 0xFF);//pSrc[src_xoff+src_x+i];	//	Gb
//			}
//		}
//	}
//	
//	//	inter-pixel interplation
//	for (int y=0, xoff=0; y<dst_h; y++, xoff+=dst_bw) {
//		for (int x=1; x<iWidth-1; x++) {
//			int csel = 1-(y%2)+(x%2);	//	color sel :	even_y&even_x=set_avg_G(1), even_y&odd_x=set_avg_R(2)
//										//				odd_y&even_x=set_avg_B(0), odd_y&odd_x=set_avg_G(1)
//			pDst[xoff+(x+0)*3+csel] = (pDst[xoff+(x-1)*3+csel] + pDst[xoff+(x+1)*3+csel])/2;
//		}
//	}
//	
//	//	inter-line interpolation
//	for (int y=1, xoff=dst_bw; y<dst_h-1; y++, xoff+=dst_bw) {
//		int csel = (y%2)*2;	//	color sel :	even_y=set_avg_B(0), odd_y=set_avg_R(2)
//		for (int x=0; x<dst_bw; x+=3) {
//			pDst[xoff+x+csel] = (pDst[xoff-dst_bw+x+csel] + pDst[xoff+dst_bw+x+csel])/2;
//		}
//	}
//}

void Xiaomi_RAW10_to_RGB24(PBYTE pSrc, int iSrcSize, PBYTE pDst, int iDstSize, int iWidth, int iHeight)
{
	memset(pDst,0,iDstSize);

	int src_bw = iWidth*5/4;
	int src_h  = iSrcSize/src_bw;

	int dst_bw = (iWidth*3+3)/4*4;
	int dst_h  = iDstSize/dst_bw;

	for (int y=0, dst_off=0, src_off=0; y<dst_h && y<src_h; y++, dst_off+=dst_bw, src_off+=src_bw) {
		for (int dst_x=0, src_x=0; dst_x<dst_bw; dst_x+=12, src_x+=5) {
			int P0 = pSrc[src_off+src_x+0];	P0 <<= 2;	if (P0>255)	P0 = 255;
			int P1 = pSrc[src_off+src_x+1];	P1 <<= 2;	if (P1>255)	P1 = 255;
			int P2 = pSrc[src_off+src_x+2];	P2 <<= 2;	if (P2>255)	P2 = 255;
			int P3 = pSrc[src_off+src_x+3];	P3 <<= 2;	if (P3>255)	P3 = 255;

			pDst[dst_off+dst_x+0]  = (BYTE)(P0);
			pDst[dst_off+dst_x+1]  = (BYTE)(P0);
			pDst[dst_off+dst_x+2]  = (BYTE)(P0);
			pDst[dst_off+dst_x+3]  = (BYTE)(P1);
			pDst[dst_off+dst_x+4]  = (BYTE)(P1);
			pDst[dst_off+dst_x+5]  = (BYTE)(P1);
			pDst[dst_off+dst_x+6]  = (BYTE)(P2);
			pDst[dst_off+dst_x+7]  = (BYTE)(P2);
			pDst[dst_off+dst_x+8]  = (BYTE)(P2);
			pDst[dst_off+dst_x+9]  = (BYTE)(P3);
			pDst[dst_off+dst_x+10] = (BYTE)(P3);
			pDst[dst_off+dst_x+11] = (BYTE)(P3);
		}
	}
}

void CSourceDlg::OnBnClickedButtonStreamStart()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	int iErrCode = DCU_ERR_SUCCESS;

	// ũƮ  Frame Grabber   о
	int iSource = 0, iWidth = 0, iHeight = 0, iBpp = 0, iSkip = 0, iFormat = 0;
	iErrCode = DCU_GetCapInfo(m_hHandle, &iSource, &iWidth, &iHeight, &iBpp, &iSkip, &iFormat);
	if(iErrCode != DCU_ERR_SUCCESS)
	{
		CString strMsg;
		strMsg.Format("ERR: DCU_GetCapInfo, %d, %s", iErrCode, DCU_GetErrMsg(iErrCode));
		LogOut(strMsg);
		return;
	}

	// Frame Grabber   
	m_iWidth	= iWidth;
	m_iHeight	= iHeight;
	m_iBpp		= iBpp;
	m_iFormat	= iFormat;

	// Frame Grabber  뿡 ˷
	if(m_pFrameCapture)
		m_pFrameCapture->OnPrepare(m_iFormat, iWidth, iHeight);

	// Frame Grabber ۽Ŵ
	iErrCode = DCU_Start(m_hHandle);
	if(iErrCode == DCU_ERR_SUCCESS)
	{
		// GetFrame / GetCancelFrame 
		m_hXferThread = (HANDLE)_beginthreadex(NULL, 0, MyThreadFunc, this, 0, &m_uXferThreadID);
		if(m_hXferThread)
			m_bXferLooping = TRUE;

		// GetFrameAsync 
		//DCU_GetFrameAsync(m_hHandle, OnEventFrameCallback, this);
		//m_bXferLooping = TRUE;

		//   
		m_StopWatch.Start();
		m_iFrameCount = 0;
	}

	UpdateButtons();
}

void CSourceDlg::OnBnClickedButtonStreamStop()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	//DCU_GetFrameAsync(m_hHandle, NULL, NULL);
	//m_bXferLooping = FALSE;

	int iErrCode = DCU_Stop(m_hHandle);

	if(m_bXferLooping)
	{
		TRACE("CSourceDlg: ENTRY STOP\n");
		m_bXferLooping = FALSE;
		DCU_CancelFrame(m_hHandle);
		WaitForSingleObject(m_hXferThread, INFINITE);
		TRACE("CSourceDlg: EXIT STOP\n");
	}

	UpdateButtons();
}

void CSourceDlg::OnBnClickedButtonStreamSave()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_bSave = true;
}

void CSourceDlg::OnBnClickedButtonClear()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	LogClear();
}

void CSourceDlg::OnCapture(PBYTE pFrame, int iLength, int iCount)
{
	if(m_bSave)
	{
		m_bSave = false;
		OnSave(pFrame, iLength);
	}

	switch(m_iFormat)
	{
	case 0: // YUV16
		YUV16toRGB24(pFrame, iLength, m_pRgb24, m_iRgb24, m_iWidth, m_iHeight);
		break;
	case 1: // RGB565
		RGB16toRGB24(pFrame, iLength, m_pRgb24, m_iRgb24, m_iWidth, m_iHeight);
		break;
	case 2: // RAW10
		Xiaomi_RAW10_to_RGB24(pFrame, iLength, m_pRgb24, m_iRgb24, m_iWidth, m_iHeight);
		break;
	}

	if(m_pFrameCapture)
		m_pFrameCapture->OnCapture(m_pRgb24, m_iWidth, m_iHeight);
}

void CSourceDlg::OnSave(PBYTE pFrame, int iLength)
{
	CFile file;
	CTime tm = CTime::GetCurrentTime();
	CString strTime = tm.Format("%Y%m%d_%H%M%S");
	CString strName;
	strName.Format("cap_%s_%d_%d.raw", strTime, m_iWidth, m_iHeight);

	if(file.Open(strName, CFile::typeBinary | CFile::modeCreate | CFile::modeWrite))
	{
		file.Write(pFrame, iLength);
		file.Close();
	}
}


unsigned CSourceDlg::MyThreadFunc(void *pContext)
{
	CSourceDlg *pDlg = (CSourceDlg *)pContext;
	CStopWatch sw(1000);
	if(pDlg)
	{
#if FLAG_DELAY_GET_FRAME
		HANDLE hTemp = CreateEvent(NULL, TRUE, FALSE, NULL);
		sw.Start();
#endif

		while(pDlg->m_bXferLooping)
		{
#if FLAG_DELAY_GET_FRAME
			ResetEvent(hTemp);
			// delay for 500 ms
			WaitForSingleObject(hTemp, 500);
#endif

			PBYTE pBuf = NULL;
			int iLength= 0;
			int iCount = 0;
			int iErrCode = DCU_GetFrame(pDlg->m_hHandle, 1, &iCount, &pBuf, &iLength);
			if(iErrCode == DCU_ERR_SUCCESS)
			{
				TRACE("GetFrame: 0x%08X, 0x%08X, %d\n", pBuf, iLength, iCount);
				if(iCount == 1)
					pDlg->OnCapture(pBuf, iLength, iCount);
				
				pDlg->m_iFrameCount++;
			}

#if FLAG_DELAY_GET_FRAME
			TRACE("Elapsed Time: %.1f ms\n", sw.GetLapTime());
#endif
		}
		TRACE("CSourceDlg: LOOP OUT\n");

#if FLAG_DELAY_GET_FRAME
		if(hTemp) CloseHandle(hTemp);
#endif
	}

	_endthreadex(0);
	return 0L;
}

void CSourceDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	double ttime = m_StopWatch.GetTotalTime(); 
	if(m_bXferLooping && ttime > 0)
	{
		double len = (m_iWidth * m_iHeight * m_iBpp + 7) / 8;
		double fps = m_iFrameCount / ttime;
		double bps = ((double)m_iFrameCount * (double)len / 1000000.0) / ttime;

		CString strMsg;
		strMsg.Format("F: %d frame, FPS: %03.2f, BPS: %08.2fM BPS", m_iFrameCount, fps, bps);
		m_editPerformance.SetWindowText(strMsg);
	}

	if(m_hHandle && !m_bXferLooping) // && !m_bNotReadStatus)
	{
		int iLen = 3;
		std::vector<DWORD> rdq(iLen);
		CString strMsg;

		int iErrCode = DCU_RegRead(m_hHandle, false, 0x40, DCU_TAG_NORMAL, &rdq[0], &iLen);
		if(iErrCode == DCU_ERR_SUCCESS)
		{
			strMsg.Format("0x%08X", rdq[0]);
			m_editMipiVsCount.SetWindowText(strMsg);
			strMsg.Format("0x%08X", rdq[1]);
			m_editMipiHsCount.SetWindowText(strMsg);
			strMsg.Format("0x%08X", rdq[2]);
			m_editMipiDeCount.SetWindowText(strMsg);
		}
	}

	CDialog::OnTimer(nIDEvent);
}


void CSourceDlg::LoadScript()
{
	UpdateData(TRUE);

	// Release Script
	ReleaseScript();

	//   *.ecs ϵ Ʈ 
	WIN32_FIND_DATA ffd;
	HANDLE hFind = INVALID_HANDLE_VALUE;
	std::string name;

	CString strDirectory = m_strScriptDirectory;
	strDirectory += "\\*.ecs";
	hFind = FindFirstFile(strDirectory, &ffd);
	if (INVALID_HANDLE_VALUE != hFind) 
	{
		do {

			if (!(ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				m_listEcs.push_back(ffd.cFileName);
			}
		}
		while(FindNextFile(hFind, &ffd));
	}

	// ư ̸ ٲ ecs  Ʈ 
	for(size_t i = 0; i < m_listEcs.size(); i++)
	{
		//  ̸ Ȯڸ 
		std::string name = m_listEcs[i].substr(0, m_listEcs[i].rfind("."));

		// ŵ ̸ 6 script ư ̸ 
		if(i < num_script_buttons)
		{
			m_btnScriptGroup[i].SetWindowTextA(name.c_str());
			m_btnScriptGroup[i].EnableWindow(TRUE);
		}
	}
}

void CSourceDlg::ReleaseScript()
{
	//  ecf Ʈ 
	m_listEcs.clear();

	//  ư ̸  ϰ Diable · 
	for(int i = 0; i < num_script_buttons; i++)
	{
		m_btnScriptGroup[i].SetWindowText("");
		m_btnScriptGroup[i].EnableWindow(FALSE);
	}
}