#pragma once

#include "afxwin.h"

#include "..\..\api\inc\dcusblib.h"
#include "IFrameCapture.h"
#include "HexEdit.h"
#include "StopWatch.h"

#include <string>
#include <vector>

using namespace std;
using namespace std::tr1;

enum FRAME_IMAGE_TYPE 
{
	FRAME_IMAGE_YUV	= 0,
	FRAME_IMAGE_RGB16,
	FRAME_IMAGE_RAW10
};

const int num_script_buttons	= 6;
const int max_frame_width		= 5000;
const int max_frame_height		= 5000;

// CSourceDlg ȭ Դϴ.

class CSourceDlg	: public CDialog
{
	DECLARE_DYNAMIC(CSourceDlg)

protected:
	IFrameCapture	*m_pFrameCapture;
	HANDLE			m_hHandle;

	//    
	HANDLE			m_hXferThread;
	unsigned		m_uXferThreadID;
	BOOL			m_bXferLooping;

	// RGB24 ȯ 
	PBYTE			m_pRgb24;
	int				m_iRgb24;
	int				m_iWidth;
	int				m_iHeight;
	int				m_iBpp;
	int				m_iFormat;

	// Performance  ɹ
	CStopWatch		m_StopWatch;
	int				m_iFrameCount;

	//   ecs ϵ ̸ Ʈ
	std::vector<std::string> m_listEcs;

	// file save flag
	bool			m_bSave;

protected:
	void OnChangeDeviceStatus(DCUSB_DEVICE_STATUS nDeviceStatus);
	void OnChangeDeviceStatus();
	void UpdateButtons();
	static void OnEventDeviceCallback(HANDLE hApiHandle, LPVOID pCallbackContext, DCUSB_DEVICE_STATUS nDeviceStatus);

	void LoadScript();
	void ReleaseScript();

	void OnCapture(PBYTE pFrame, int iLength, int iCount);
	void OnSave(PBYTE pFrame, int iLength);

	void OnFrameCallback(HANDLE hDevice, PVOID pFrame, int iLength);
	static void OnEventFrameCallback(HANDLE hDevice, PVOID pContext, PVOID pFrame, int iLength);

	static unsigned __stdcall MyThreadFunc(void *);

public:
	CSourceDlg(IFrameCapture *pFrameCapture);   // ǥ Դϴ.
	virtual ~CSourceDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_DIALOG_SOURCE };

	// log functions
	void LogOut(LPCTSTR lpszMsg);
	void LogOut(char *fmt, ...);
	void LogClear();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	DECLARE_MESSAGE_MAP()
	virtual void OnOK();
	virtual void OnCancel();
public:
	CComboBox m_cmbSelectDevice;
	CHexEdit m_edAddress;
	CHexEdit m_edReadCount;
	BOOL m_bFixed;
	CString m_strData;
	CButton m_btnWrite;
	CButton m_btnRead;
	CString m_strScriptDirectory;
	CButton m_btnStreamStart;
	CButton m_btnStreamStop;
	CListBox m_listLog;
	CEdit m_editMipiVsCount;
	CEdit m_editMipiHsCount;
	CEdit m_editMipiDeCount;
	CButton m_btnStreamSave;
	CEdit m_editPerformance;

	// ũƮ ϴ ư
	CButton m_btnScriptGroup[num_script_buttons];

	afx_msg void OnBnClickedButtonWrite();
	afx_msg void OnBnClickedButtonRead();
	afx_msg void OnDestroy();
	virtual BOOL OnInitDialog();
	afx_msg void OnCbnSelchangeComboSelectDevice();
	afx_msg void OnBnClickedButtonBrowseScript();
	afx_msg void OnBnClickedButtonStreamStart();
	afx_msg void OnBnClickedButtonStreamStop();
	afx_msg void OnBnClickedButtonsGroups(UINT nID);
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedButtonStreamSave();
};
