
// viewUsb3View.cpp : implementation of the CviewUsb3View class
//

#include "stdafx.h"
#include "viewUsb3.h"

#include "viewUsb3Doc.h"
#include "viewUsb3View.h"

#include "ZMemDC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MAX_ZOOMFIX		18
#define ORG_ZOOMFIX		6
const float	c_fZoomFix[MAX_ZOOMFIX]
	= { 0.1f, 0.2f, 0.4f, 0.5f, 0.75f, 0.8f, 1.0f, 1.2f, 1.5f, 2.0f, 3.0f, 4.0f, 5.0f, 6.0f, 7.0f, 8.0f, 9.0f, 10.0f };

// CviewUsb3View

IMPLEMENT_DYNCREATE(CviewUsb3View, CScrollView)

BEGIN_MESSAGE_MAP(CviewUsb3View, CScrollView)
	// Standard printing commands
	ON_COMMAND(ID_ZOOM_INCREASE, &CviewUsb3View::OnZoomIncrease)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_INCREASE, &CviewUsb3View::OnUpdateZoomIncrease)
	ON_COMMAND(ID_ZOOM_DECREASE, &CviewUsb3View::OnZoomDecrease)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_DECREASE, &CviewUsb3View::OnUpdateZoomDecrease)
	ON_COMMAND(ID_ZOOM_ORIGINAL, &CviewUsb3View::OnZoomOriginal)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_ORIGINAL, &CviewUsb3View::OnUpdateZoomOriginal)
	ON_COMMAND(ID_ZOOM_FITWINDOW, &CviewUsb3View::OnZoomFitwindow)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_FITWINDOW, &CviewUsb3View::OnUpdateZoomFitwindow)
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

// CviewUsb3View construction/destruction

CviewUsb3View::CviewUsb3View()
{
	// TODO: add construction code here
	m_iZooms = ORG_ZOOMFIX;
	m_fZoom = c_fZoomFix[m_iZooms];

	m_nImgOffsetX = 0;
	m_nImgOffsetY = 0;

	SetScrollSizes( MM_TEXT, CSize(0,0) );
}

CviewUsb3View::~CviewUsb3View()
{
}

BOOL CviewUsb3View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

// CviewUsb3View drawing

void CviewUsb3View::OnDraw(CDC* pDC)
{
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here

	if(pDoc->m_Img.IsValid())
	{
		CZMemDC	dcMem(pDC);
		pDC = &dcMem;

		int cxImg = static_cast<int>(pDoc->m_Img.GetWidth() * getZoom());
		int cyImg = static_cast<int>(pDoc->m_Img.GetHeight() * getZoom());

		CSize szTotal(GetTotalSize());
		CRect rect;
		GetClientRect(rect);
		rect.OffsetRect(GetScrollPos(SB_HORZ), GetScrollPos(SB_VERT));
		CBrush br(HS_DIAGCROSS, RGB(192, 163, 163));
		//pDC->FillSolidRect( rect, RGB(192, 192, 220) );
		pDC->FillRect( rect, &br );

		m_nImgOffsetX = (max(szTotal.cx, rect.Width())-cxImg)/2;
		m_nImgOffsetY = (max(szTotal.cy, rect.Height())-cyImg)/2;
		pDoc->m_Img.Draw( pDC->GetSafeHdc(), m_nImgOffsetX, m_nImgOffsetY, cxImg, cyImg );
	}
}

void CviewUsb3View::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	//CSize sizeTotal;
	// TODO: calculate the total size of this view
	//sizeTotal.cx = sizeTotal.cy = 100;
	//SetScrollSizes(MM_TEXT, sizeTotal);
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}

void CviewUsb3View::OnRButtonUp(UINT nFlags, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CviewUsb3View::OnContextMenu(CWnd* pWnd, CPoint point)
{
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
}


// CviewUsb3View diagnostics

#ifdef _DEBUG
void CviewUsb3View::AssertValid() const
{
	CScrollView::AssertValid();
}

void CviewUsb3View::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CviewUsb3Doc* CviewUsb3View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CviewUsb3Doc)));
	return (CviewUsb3Doc*)m_pDocument;
}
#endif //_DEBUG


void CviewUsb3View::setZoom(float fZoom)
{
	m_fZoom = fZoom;

	// Էµ Zoom  缭 
	m_iZooms = 0;
	for(int i = 0; i < MAX_ZOOMFIX; i++)
	{
		if(m_fZoom > c_fZoomFix[i])
			m_iZooms = i;
	}
}

void CviewUsb3View::incZoom()
{
	m_iZooms++;
	if(m_iZooms >= MAX_ZOOMFIX)
		m_iZooms = MAX_ZOOMFIX - 1;
	m_fZoom = c_fZoomFix[m_iZooms];
}

void CviewUsb3View::decZoom()
{
	m_iZooms--;
	if(m_iZooms < 0)
		m_iZooms = 0;
	m_fZoom = c_fZoomFix[m_iZooms];
}

void CviewUsb3View::oriZoom()
{
	m_iZooms = ORG_ZOOMFIX;
	m_fZoom = c_fZoomFix[m_iZooms];
}

void CviewUsb3View::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	//////////////////////////
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	//////////////////////////
	if ( pDoc->m_Img.IsValid() )
	{
		int cxImg = static_cast<int>(pDoc->m_Img.GetWidth() * getZoom());
		int cyImg = static_cast<int>(pDoc->m_Img.GetHeight() * getZoom());

		CRect rcChildClient;
		GetClientRect(rcChildClient);

		CSize szTotal(GetTotalSize());

		SetScrollSizes( MM_TEXT, CSize(cxImg, cyImg) );
		//////////////////////////////////////////

		switch(lHint)
		{
		case HINT_UPDATE_OPEN_IMAGE:
			{
				SetScrollPos( SB_HORZ, 0 );
				SetScrollPos( SB_VERT, 0 );
			}
			break;
		case HINT_UPDATE_FIT_WINDOW:
			{
			}
			break;
		case HINT_UPDATE_ZOOM_IMAGE:
			{
				if ( szTotal.cx!=0 && szTotal.cy!=0 )
				{
					if ( cxImg > rcChildClient.right ) SetScrollPos(SB_HORZ, szTotal.cx / 2 );
					else SetScrollPos( SB_HORZ, 0 );
					
					if ( cyImg > rcChildClient.bottom ) SetScrollPos(SB_VERT, szTotal.cy / 2 );
					else SetScrollPos( SB_VERT, 0 );
				}
			}
			break;
		}

		//////////////////////////////////////////
		Invalidate();
	}

	//////////////////////////////////////////////
	CScrollView::OnUpdate(pSender, lHint, pHint);
}

void CviewUsb3View::OnZoomIncrease()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	incZoom();
	OnUpdate(NULL, HINT_UPDATE_ZOOM_IMAGE, NULL);
}

void CviewUsb3View::OnUpdateZoomIncrease(CCmdUI *pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pCmdUI->Enable( pDoc->m_Img.IsValid() );
}

void CviewUsb3View::OnZoomDecrease()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	decZoom();
	OnUpdate(NULL, HINT_UPDATE_ZOOM_IMAGE, NULL);
}

void CviewUsb3View::OnUpdateZoomDecrease(CCmdUI *pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pCmdUI->Enable( pDoc->m_Img.IsValid() );
}

void CviewUsb3View::OnZoomOriginal()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	oriZoom();
	OnUpdate(NULL, HINT_UPDATE_ZOOM_IMAGE, NULL);
}

void CviewUsb3View::OnUpdateZoomOriginal(CCmdUI *pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pCmdUI->Enable( pDoc->m_Img.IsValid() );
}

void CviewUsb3View::OnZoomFitwindow()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );

	CRect rcChildClient;
	GetClientRect(rcChildClient);
	float fRatioX = (rcChildClient.Width()-4.0f) / (float)(pDoc->m_Img.GetWidth());
	float fRatioY = (rcChildClient.Height()-4.0f) / (float)(pDoc->m_Img.GetHeight());

	if ( fRatioX < fRatioY ) 
		setZoom(fRatioX);
	else 
		setZoom(fRatioY);

	OnUpdate(NULL, HINT_UPDATE_FIT_WINDOW, NULL);

	//cxImg = pDoc->m_Mod.GetImgDrawWidth();
	//cyImg = pDoc->m_Mod.GetImgDrawHeight();
	//SetScrollSizes( MM_TEXT, CSize(rcChildClient.Width(), rcChildClient.Height()) );
}

void CviewUsb3View::OnUpdateZoomFitwindow(CCmdUI *pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	CviewUsb3Doc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pCmdUI->Enable( pDoc->m_Img.IsValid() );
}

BOOL CviewUsb3View::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	return FALSE;

	//return CScrollView::OnEraseBkgnd(pDC);
}
