
// viewUsb3View.h : interface of the CviewUsb3View class
//


#pragma once

#include <math.h>

class CviewUsb3View : public CScrollView
{
protected: // create from serialization only
	CviewUsb3View();
	DECLARE_DYNCREATE(CviewUsb3View)

// Attributes
protected:
	float m_fZoom;
	int	m_iZooms;

	int	m_nImgOffsetX;
	int	m_nImgOffsetY;

public:
	CviewUsb3Doc* GetDocument() const;

// Operations
public:
	inline int roundUp(double dValue) { return (int)floor(dValue + 0.5); }

	float getZoom() { return m_fZoom; }
	void setZoom(float fZoom);
	void incZoom();
	void decZoom();
	void oriZoom();

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct

// Implementation
public:
	virtual ~CviewUsb3View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	afx_msg void OnFilePrintPreview();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	DECLARE_MESSAGE_MAP()
public:
protected:
	virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
public:
	afx_msg void OnZoomIncrease();
	afx_msg void OnUpdateZoomIncrease(CCmdUI *pCmdUI);
	afx_msg void OnZoomDecrease();
	afx_msg void OnUpdateZoomDecrease(CCmdUI *pCmdUI);
	afx_msg void OnZoomOriginal();
	afx_msg void OnUpdateZoomOriginal(CCmdUI *pCmdUI);
	afx_msg void OnZoomFitwindow();
	afx_msg void OnUpdateZoomFitwindow(CCmdUI *pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
};

#ifndef _DEBUG  // debug version in viewUsb3View.cpp
inline CviewUsb3Doc* CviewUsb3View::GetDocument() const
   { return reinterpret_cast<CviewUsb3Doc*>(m_pDocument); }
#endif

